FUNCTION DrawBitmap(hDC AS WORD, hBitmap AS WORD, xPos AS SHORT, yPos AS SHORT, xOrg AS SHORT, yOrg AS SHORT, wOrg AS SHORT, hOrg AS SHORT, nRop AS LONG) AS VOID STRICT
// Syntax:- DrawBitmap(	<hDestDC>,;		// DC to draw on
//						<hSrcBmp>,;		// handle of bitmap to draw
//						<xPos>,<yPos>,;	// position to draw bitmap
//						<xOrg>,<yOrg>,;	// top-left corner of portion of bitmap to draw
//						<wOrg>,<hOrg>,;	// size of portion of bitmap to draw
//						<nRop>)			// ROP mode to use
	LOCAL sBmpInfo:=MemAlloc(_SizeOf(_WINBITMAP)) AS _WINBITMAP
	LOCAL hBmpDC AS WORD
	LOCAL ptSize:=MemAlloc(_SizeOf(_WINPOINT)) AS _WINPOINT
	LOCAL ptOrg:=MemAlloc(_SizeOf(_WINPOINT)) AS _WINPOINT
	// create DC 
	hBmpDC:=CreateCompatibleDC(hDC)
	SelectObject(hBmpDC,hBitmap)
	SetMapMode(hBmpDC,GetMapMode(hDC))
	// determine size of portion of bitmap to paint...
	IF wOrg==0	// width not specified, assume entire bitmap width
		GetObject(hBitmap,_SizeOf(_WINBITMAP),sBmpInfo)
		ptSize.x:=sBmpInfo.bmWidth
	ELSE
		ptSize.x:=wOrg
	ENDIF
	IF hOrg==0	// height not specified, assume entire bitmap height
		GetObject(hBitmap,_SizeOf(_WINBITMAP),sBmpInfo)
		ptSize.y:=sBmpInfo.bmHeight
	ELSE
		ptSize.y:=hOrg
	ENDIF
    // device points to logical points the size in the target DC...
	DPtoLP(hDC,ptSize,1)
	// device points to Logical points the origin in the BMP DC...
	ptOrg.x:=xOrg
	ptOrg.y:=yOrg
	DPtoLP(hBmpDC,ptOrg,1)
	// Blat it...
	BitBlt(hDC,xPos,yPos,ptSize.x,ptSize.y,hBmpDC,ptOrg.x,ptOrg.y,nRop)
	// tidy up
	DeleteDC(hBmpDC)
	MemFree(sBmpInfo)
	MemFree(ptSize)
	MemFree(ptOrg)
	RETURN